--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_state.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_state.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,184 @@
+/* Name: mausb_state.h 
+ * Description: Contains all of the state variables for hosts and devices as 
+ * defined by the MAUSB spec. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#ifndef __MAUSB_STATE_H 
+#define __MAUSB_STATE_H 
+ 
+/** 
+ * MAUSB endpoint state variables, per MA USB Spec sections 5.4.1 & 5.5.2. 
+ * 
+ * Note: this struct contains the fields necessary to store the state on both 
+ * the host and device side. 
+ * 
+ * @seq_number: For a sender, this field contains the sequence number 
+ * that should be placed in the next outgoing packet. 
+ * For a receiver, this field contains the sequence number 
+ * expected in the next incoming packet. 
+ * @keep_alive_timer: Timeout counter. Set to aMausbTransferKeepAlive 
+ * upon a new transfer initialization. To be decremented 
+ * every aMAUSBTransferTimeTick interval. If the timer 
+ * reaches 0, A retry is triggered. 
+ * @retry_counter: Indicates how many more times the 
+ * transfer will be attempted. Decremented upon a timeout 
+ * (see keep_alive_timer for details). If this counter 
+ * reaches 0, the transfer fails due to a timeout. 
+ * @request_id: Request ID number. for IN transfers, all 
+ * transfer_request packets currently being sent or 
+ * received should have this request ID number. for OUT 
+ * transfers, All transfer_request and transfer_ack 
+ * packets currently being sent or received should have 
+ * this request ID number. 
+ * @active_request_id: Active Request ID number. used by IN transfers only. 
+ * All transfer_ack packets being sent/received should 
+ * contain this number. 
+ * @earliest_unacked: Stores the sequence number of the most recent packet 
+ * that has been sent out but has not been acknowledged 
+ * by the receiver. 
+ * @rx_buf_size: Receiver Buffer Size. Used for OUT transfers only. 
+ * Indicates the available buffer space for packets in the 
+ * device (in bytes). 
+ * Note: this value is signed for the host and 
+ * unsigned for the receiver. A negative number 
+ * indicates a buffer overflow. 
+ * Note: defined in spec as a 25-bit signed int 
+ * for a host and a 32-bit unsigned for a device. 
+ * @occupancy: Size (in bytes) of the payload accepted into the receive 
+ * buffer. Used only on the device side for OUT transfers. 
+ * @earliest_request_id:Request ID of earliest transferReq whose state 
+ * needs to be tracked (host IN). 
+ * @transfer_retries: Reload value for retry_counter. Should be set to 
+ * a ControlTransferRetries, aBulkTransferRetries, 
+ * or aInterruptTransferRetries depending on transfer 
+ * type. 
+ * @delayed: Set to true if the interval between two sucessive 
+ * transferResp packets exceeds aTransferRepeatTime. 
+ * @tx_pending: Set to 1 when a transfer is in progress, otherwise it 
+ * should be zero. A new transfer cannot be started until 
+ * this flag is cleared. 
+ */ 
+struct mausb_ep_state { /* HOST | DEVICE */ 
+ 
+ unsigned int seq_number:24; /* IN | OUT | IN | OUT */ 
+ int keep_alive_timer; /* IN | OUT | IN | OUT */ 
+ unsigned int retry_counter; /* IN | OUT | IN | OUT */ 
+ __u8 request_id; /* IN | OUT | IN | OUT */ 
+ __u8 active_request_id; /* IN | OUT | IN | */ 
+ unsigned int earliest_unacked:24; /* | OUT | IN | OUT */ 
+ __u32 rx_buf_size; /* | OUT | | OUT */ 
+ unsigned int occupancy; /* | | | OUT */ 
+ u8 earliest_request_id; /* IN | OUT | IN | OUT */ 
+ unsigned int transfer_retries; /* IN | OUT | IN | OUT */ 
+ bool delayed; /* | | IN | */ 
+ 
+ /* TODO: add response_timer (device IN and OUT/host OUT) */ 
+ 
+ unsigned int tx_pending:1; /* beyond spec */ 
+}; 
+ 
+/** 
+ * MA USB transfer state variables, per section 5.4.1 & 5.5.2. 
+ * 
+ * In our implementation, URBs and MAUSB transfers map one-to-one, 
+ * so the transfer state and the urb state are one in the same. 
+ * 
+ * @rem_size: The remaining transfer size (in bytes). This value is 
+ * set at the beginning of a transfer and is decremented 
+ * as data is received. 
+ * @payload_size: Payload size for out transfer (in bytes). For MA USB 
+ * host, it indicates the overall transfered OUT payload 
+ * size for the current urb. For MA USB device, It 
+ * indicates the received OUT payload size for the 
+ * current MA USB OUT request. 
+ * @transfer_error: A boolean which is only set to TRUE when a 
+ * non-recoverable error is detected in the transfer. 
+ * @transfer_complete: A boolean which is only set to TRUE when a transfer 
+ * is evaluated to be complete. (ie. the final ACK has 
+ * has been sent/received). 
+ * @eot_detected: A boolean which is only set to TRUE when a transfer 
+ * is complete (ie: all the data has been transferred). 
+ * Note: eot_detected & transfer_complete differ in when 
+ * they are set. eot_detected is sent after the last data 
+ * packet received, transfer_complete is set after the 
+ * final ACK. 
+ * @last_transfer_sn: Last Transfer Sequence Number. Stores the sequence 
+ * number of the final packet of this transfer. 
+ * @transfer_acked: Set to true when a transferReq or transferAck packet is 
+ * released to the data channel acknowledging the last 
+ * transferResp belonging to a transfer. 
+ * @k: A transfer-dependent multiplicative factor used to 
+ * reload keep_alive_timer when a transfer has a status 
+ * of TRANSFER_PENDING. 
+ * @ack_transfer_sn: The value of the sequence number in the last 
+ * transferReq packet that belongs to the transfer and 
+ * has the ARQ field set to 1. 
+ */ 
+struct mausb_transfer_state { /* HOST | DEVICE */ 
+ 
+ __u32 rem_size; /* IN | OUT | IN | OUT */ 
+ __u32 payload_size; /* IN | OUT | IN | OUT */ 
+ bool transfer_error; /* IN | OUT | IN | OUT */ 
+ bool transfer_complete; /* IN | OUT | IN | OUT */ 
+ bool eot_detected; /* IN | | IN | OUT */ 
+ unsigned int last_transfer_sn:24; /* IN | | IN | */ 
+ bool transfer_acked; /* IN | OUT | | */ 
+ unsigned int k; /* IN | | | */ 
+ unsigned int ack_transfer_sn:24; /* | OUT | | */ 
+ 
+ /*TODO: add transfer_completion_timer (host IN) */ 
+}; 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tcp.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tcp.c
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tcp.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tcp.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,458 @@
+/* Name: mausb_tcp.c 
+ * Description: This is a driver used to connect an MA USB driver to a tcp 
+ * socket. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include <linux/module.h> 
+#include <linux/uio.h> 
+#include <linux/delay.h> 
+ 
+#include "mausb_ioctl.h" 
+#include "mausb_tcp.h" 
+ 
+struct mausb_tcp_medium *tcp_medium[MAUSB_TCP_NUM_MODS]; 
+ 
+static int gadget_connect_thread(void *data_p) 
+{ 
+ struct mausb_connect_data *data = data_p; 
+ int ret; 
+ 
+ pr_debug("%s: Running thread #%i\n", __func__, data->i); 
+ 
+ ret = tcp_medium[data->i]->connect(data->on); 
+ 
+ pr_debug("%s: Thread #%i complete, returing with value %i\n", 
+ __func__, data->i, ret); 
+ 
+ kfree(data); 
+ 
+ return ret; 
+} 
+ 
+/* for IOCTL */ 
+int gadget_connection(int on) 
+{ 
+ int i; 
+ 
+ struct mausb_connect_data *data; 
+ 
+ /* make all the calls */ 
+ for (i = 0; i < MAUSB_TCP_NUM_MODS; ++i) { 
+ 
+ if (NULL != tcp_medium[i] && 
+ NULL != tcp_medium[i]->ma_driver) { 
+ 
+ data = kzalloc(sizeof(*data), GFP_KERNEL); 
+ if (NULL == data) 
+ return -ENOMEM; 
+ 
+ data->task = NULL; 
+ data->on = on; 
+ data->i = i; 
+ 
+ pr_debug("%s: spawning thread #%i\n", __func__, i); 
+ 
+ data->task = kthread_run(gadget_connect_thread, 
+ data, "mausb_connect_thread_%i", i); 
+ } 
+ } 
+ 
+ return 0; 
+} 
+ 
+/* for IOCTL */ 
+int set_medium_delay(int delay) 
+{ 
+ pr_err("%s: ERROR: cannot set latency of real medium\n", __func__); 
+ return -EINVAL; 
+} 
+ 
+int set_port_no(int port) 
+{ 
+ int ret = -EINVAL; 
+ int i; 
+ 
+ for (i = 0; i < MAUSB_TCP_NUM_MODS; ++i) { 
+ if (NULL != tcp_medium[i]) { 
+ tcp_medium[i]->addr_in.sin_port = htons(port); 
+ ret = port; 
+ } 
+ } 
+ 
+ return ret; 
+} 
+ 
+int set_ip_addr(unsigned long in_addr) 
+{ 
+ int ret = -EINVAL; 
+ int i; 
+ struct in_addr addr; 
+ 
+ addr.s_addr = htonl(in_addr); 
+ 
+ for (i = 0; i < MAUSB_TCP_NUM_MODS; ++i) { 
+ if (NULL != tcp_medium[i]) { 
+ tcp_medium[i]->addr_in.sin_addr = addr; 
+ ret = 0; 
+ } 
+ } 
+ 
+ return ret; 
+} 
+ 
+int set_mac_addr(unsigned char mac_addr[ETH_ALEN]) 
+{ 
+ pr_err("%s: ERROR: cannot set mac address for TCP\n", __func__); 
+ return -EINVAL; 
+} 
+ 
+inline void *mausb_tcp_to_context(struct mausb_tcp_medium *medium) 
+{ 
+ return (void *) medium; 
+} 
+EXPORT_SYMBOL(mausb_tcp_to_context); 
+ 
+inline struct mausb_tcp_medium *mausb_context_to_tcp(void *context) 
+{ 
+ return (struct mausb_tcp_medium *) context; 
+} 
+EXPORT_SYMBOL(mausb_context_to_tcp); 
+ 
+static void mausb_tcp_init_msg(struct msghdr *msg) 
+{ 
+ msg->msg_name = NULL; 
+ msg->msg_namelen = 0; 
+ msg->msg_control = NULL; 
+ msg->msg_controllen = 0; 
+ msg->msg_flags = 0; 
+} 
+ 
+static int mausb_tcp_enqueue(struct ms_pkt *pkt, void *context) 
+{ 
+ struct msghdr msg; 
+ struct mausb_tcp_medium *tcp_medium; 
+ int total_length = 0; 
+ int ret = 0; 
+ int i; 
+ 
+ mausb_tcp_init_msg(&msg); 
+ 
+ if (NULL == context) { 
+ pr_err("%s: ERROR: null context\n", __func__); 
+ return -EINVAL; 
+ } 
+ tcp_medium = mausb_context_to_tcp(context); 
+ 
+ if (NULL == tcp_medium->socket) { 
+ pr_err("%s: ERROR: no socket for packet\n", __func__); 
+ return -ENOTCONN; 
+ } 
+ 
+ for (i = 0; i < pkt->nents; ++i) { 
+ total_length += pkt->kvec[i].iov_len; 
+ } 
+ 
+ ret = kernel_sendmsg(tcp_medium->socket, &msg, pkt->kvec, pkt->nents, 
+ total_length); 
+ 
+ pr_debug("%s: sent %i bytes\n", __func__, ret); 
+ 
+ /* 
+ * TODO: implement completion (pkt_sent) callback 
+ * if (NULL != tcp_medium->tx_pair.pkt_sent && 0 < ret) 
+ * tcp_pair->tx_pair.pkt_sent(pkt); 
+ */ 
+ 
+ return ret; 
+} 
+ 
+static int mausb_tcp_receive_packet(struct mausb_tcp_medium *tcp_medium, 
+ struct msghdr *msg, struct ms_pkt *pkt) 
+{ 
+ struct kvec kvec; 
+ int data_rcvd; 
+ int total_rcvd = 0; 
+ __u16 length; 
+ void *buf; 
+ 
+ buf = kmalloc(MAUSB_TCP_BUF_SIZE, GFP_KERNEL); 
+ if (NULL == buf) 
+ return -ENOMEM; 
+ 
+ kvec.iov_base = buf; 
+ kvec.iov_len = MAUSB_TCP_BUF_SIZE; 
+ 
+ /* receive the first DWORD to determine length */ 
+ data_rcvd = kernel_recvmsg(tcp_medium->socket, msg, &kvec, 1, 
+ sizeof(__u32), MSG_DONTWAIT); 
+ 
+ while (data_rcvd == -EAGAIN && !kthread_should_stop()) { 
+ /* sleep to prevent excessive polling */ 
+ msleep(10); 
+ 
+ /* receive the first DWORD to determine length */ 
+ data_rcvd = kernel_recvmsg(tcp_medium->socket, msg, &kvec, 
+ 1, sizeof(__u32), MSG_DONTWAIT); 
+ } 
+ 
+ if (0 > data_rcvd) { 
+ pr_err("%s: ERROR: Could not read packet length" 
+ " (error #%i)\n", __func__, data_rcvd); 
+ kfree(buf); 
+ return data_rcvd; 
+ } 
+ 
+ /* the data is invalid */ 
+ if (sizeof(__u32) > data_rcvd) { 
+ pr_err("%s: ERROR: did not read enough data to get length" 
+ " (received %i bytes)\n", __func__, data_rcvd); 
+ kfree(buf); 
+ return -EINVAL; 
+ } 
+ 
+ length = le16_to_cpu(*((__le16 *)(buf + MAUSB_PKT_LENGTH_OFFSET))); 
+ total_rcvd += data_rcvd; 
+ 
+ /* make sure length is valid */ 
+ if (length < sizeof(__u32)) { 
+ pr_err("%s: ERROR: length field too small (%u)\n", 
+ __func__, length); 
+ kfree(buf); 
+ return -EINVAL; 
+ } 
+ 
+ /* receive the remainder of the packet */ 
+ while (total_rcvd < length && total_rcvd >= 0 && 
+ !kthread_should_stop()) { 
+ 
+ data_rcvd = kernel_recvmsg(tcp_medium->socket, msg, &kvec, 
+ 1, length - total_rcvd, 0); 
+ 
+ if (0 < data_rcvd) { 
+ total_rcvd += data_rcvd; 
+ 
+ } else if (0 > data_rcvd) { 
+ pr_err("%s: ERROR: while receiving packet " 
+ "(err #%i)\n", __func__, data_rcvd); 
+ kfree(buf); 
+ return data_rcvd; 
+ } 
+ } 
+ 
+ if (total_rcvd != length) { 
+ pr_warn("%s: Warning: did not receive enough data " 
+ "(length:%u, received:%i)\n", __func__, 
+ length, total_rcvd); 
+ } 
+ 
+ 
+ pkt->nents = 1; 
+ pkt->kvec[0].iov_base = buf; 
+ pkt->kvec[0].iov_len = total_rcvd; 
+ 
+ return total_rcvd; 
+} 
+ 
+int mausb_tcp_receive_loop(struct mausb_tcp_medium *tcp_medium) 
+{ 
+ struct msghdr msg; 
+ struct ms_pkt *pkt; 
+ int data_rcvd = 0; 
+ 
+ mausb_tcp_init_msg(&msg); 
+ 
+ while (!kthread_should_stop()) { 
+ 
+ pkt = kzalloc(sizeof(struct ms_pkt), GFP_KERNEL); 
+ 
+ pr_debug("%s: preparing to receive data\n", __func__); 
+ 
+ data_rcvd = mausb_tcp_receive_packet(tcp_medium, &msg, pkt); 
+ 
+ if (0 >= data_rcvd) { 
+ pr_err("%s: received no data (err %i)\n", __func__, 
+ data_rcvd); 
+ 
+ sock_release(tcp_medium->socket); 
+ return data_rcvd; 
+ 
+ } else { 
+ pr_debug("%s: received %i bytes\n", __func__, 
+ data_rcvd); 
+ } 
+ 
+ if (data_rcvd > 0) { 
+ mausb_transfer_packet(pkt, 
+ &tcp_medium->ma_driver->pkt_dmux); 
+ } 
+ 
+ data_rcvd = 0; 
+ } 
+ 
+ sock_release(tcp_medium->socket); 
+ 
+ return 0; 
+} 
+EXPORT_SYMBOL(mausb_tcp_receive_loop); 
+ 
+int mausb_tcp_add_tx_pair(struct mausb_transfer_pair *ma_pair, 
+ struct mausb_tcp_medium *medium) 
+{ 
+ ma_pair->to_ms.transfer_packet = &mausb_tcp_enqueue; 
+ ma_pair->to_ms.context = mausb_tcp_to_context(medium); 
+ 
+ return 0; 
+} 
+EXPORT_SYMBOL(mausb_tcp_add_tx_pair); 
+ 
+int mausb_tcp_drop_tx_pair(unsigned long handle, void *context) 
+{ 
+ /* TODO: something here */ 
+ 
+ return 0; 
+} 
+EXPORT_SYMBOL(mausb_tcp_drop_tx_pair); 
+
+/** 
+ * Frees the given ms_pkt and associated buffers. This function is not 
+ * necessary to use the API, but could be useful on both sides of the interface. 
+ */ 
+void mausb_free_ms_pkt(struct ms_pkt *pkt) 
+{ 
+ int i; 
+ void *current_buf; 
+ 
+ for (i = 0; i < pkt->nents; ++i) { 
+ current_buf = pkt->kvec[i].iov_base; 
+ if (NULL != current_buf) { 
+ kfree(current_buf); 
+ } else { 
+ pr_debug("%s: cannot find buffer for kvec #%i in" 
+ " ms_pkt at %p\n", __func__, i, pkt->kvec); 
+ } 
+ } 
+ 
+ kfree(pkt); 
+} 
+EXPORT_SYMBOL(mausb_free_ms_pkt); 
+ 
+/** 
+ * initialization function 
+ */ 
+struct mausb_tcp_medium *alloc_init_mausb_tcp_medium( 
+ enum mausb_tcp_module_type type) 
+{ 
+ struct mausb_tcp_medium *medium; 
+ int ret; 
+ 
+ medium = kzalloc(sizeof(struct mausb_tcp_medium), GFP_KERNEL); 
+ if (NULL == medium) 
+ return NULL; 
+ 
+ ret = sock_create(PF_INET, SOCK_STREAM, IPPROTO_TCP, 
+ &medium->setup_socket); 
+ 
+ medium->addr_in.sin_family = AF_INET; 
+ medium->addr_in.sin_port = htons(MAUSB_TCP_PORT_HOST); 
+ 
+ spin_lock_init(&medium->lock); 
+ 
+ tcp_medium[type] = medium; 
+ 
+ return medium; 
+} 
+EXPORT_SYMBOL(alloc_init_mausb_tcp_medium); 
+ 
+/** 
+ * exit function 
+ */ 
+void free_mausb_tcp_medium(struct mausb_tcp_medium *medium, 
+ enum mausb_tcp_module_type type) 
+{ 
+ if (medium->recv_task) 
+ kthread_stop(medium->recv_task); 
+ 
+ if (medium->setup_socket) 
+ sock_release(medium->setup_socket); 
+ 
+ tcp_medium[type] = NULL; 
+ 
+ kfree(medium); 
+} 
+EXPORT_SYMBOL(free_mausb_tcp_medium); 
+ 
+int mausb_tcp_core_init(void) 
+{ 
+ int ret; 
+ 
+ ret = reg_chrdev(); 
+ if (0 > ret) { 
+ pr_err("%s: reg_chrdev() failed\n", __func__); 
+ } 
+ 
+ return ret; 
+ 
+} 
+module_init(mausb_tcp_core_init); 
+ 
+void mausb_tcp_core_exit(void) 
+{ 
+ unreg_chrdev(); 
+} 
+module_exit(mausb_tcp_core_exit); 
+ 
+MODULE_LICENSE("Dual BSD/GPL"); 
+MODULE_AUTHOR("Intel"); 
+MODULE_DESCRIPTION("mausb_tcp_core"); 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tcp-device.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tcp-device.c
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tcp-device.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tcp-device.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,147 @@
+/* Name: mausb_tcp-device.c 
+ * Description: The device side media specific driver to allow media agnostic 
+ * packets over tcp/ip. 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include <linux/module.h> 
+#include <linux/init.h> 
+ 
+#include "mausb_tcp.h" 
+#include "mausb_ioctl.h" 
+ 
+struct mausb_tcp_medium *dev_tcp_medium; 
+ 
+int mausb_tcp_device_thread(void *data) 
+{ 
+ return mausb_tcp_receive_loop(dev_tcp_medium); 
+} 
+ 
+int mausb_tcp_device_add_tx_pair(struct mausb_transfer_pair *ma_pair) 
+{ 
+ return mausb_tcp_add_tx_pair(ma_pair, dev_tcp_medium); 
+} 
+ 
+static struct mausb_ms_ops ms_ops = { 
+ .add_transfer_pair = &mausb_tcp_device_add_tx_pair, 
+ .drop_transfer_pair = &mausb_tcp_drop_tx_pair, 
+ .pkt_destructor = &mausb_free_ms_pkt 
+}; 
+ 
+static struct mausb_ms_drv ms_driver = { 
+ .ops = &ms_ops 
+}; 
+ 
+static int mausb_tcp_device_connect(int on) 
+{ 
+ int ret; 
+ 
+ if (on && dev_tcp_medium->socket == NULL) { 
+ ret = sock_create(PF_INET, SOCK_STREAM, IPPROTO_TCP, 
+ &dev_tcp_medium->socket); 
+ 
+ if (0 > ret) /* TODO: real errorchecking */ 
+ return ret; 
+ 
+ do { 
+ ret = kernel_connect(dev_tcp_medium->socket, 
+ &dev_tcp_medium->addr, 
+ sizeof(dev_tcp_medium->addr_in), O_RDWR); 
+ pr_debug("%s:kernel_connect returned %i\n", 
+ __func__, ret); 
+ 
+ if (0 > ret) { 
+ /* poll until we can connect sucessfully */ 
+ msleep(MAUSB_TCP_DEV_CONNECT_POLL_MS); 
+ } 
+ 
+ 
+ } while (0 > ret); 
+ 
+ /*spawn off a listening thread */ 
+ dev_tcp_medium->recv_task = kthread_run(mausb_tcp_device_thread, 
+ NULL, "mausb_tcp_device_thread"); 
+ } 
+ 
+ ret = dev_tcp_medium->ma_driver->device_connect(on); 
+ 
+ return ret; 
+} 
+ 
+int mausb_tcp_device_init(void) 
+{ 
+ dev_tcp_medium = alloc_init_mausb_tcp_medium(MAUSB_TCP_DEV); 
+ if (NULL == dev_tcp_medium) 
+ return -ENOMEM; 
+ 
+ dev_tcp_medium->addr_in.sin_addr.s_addr = htonl(INADDR_LOOPBACK); 
+ 
+ dev_tcp_medium->connect = &mausb_tcp_device_connect; 
+ 
+ dev_tcp_medium->ma_driver = maudc_register_ms_driver(&ms_driver); 
+ 
+ 
+ return 0; 
+} 
+module_init(mausb_tcp_device_init); 
+ 
+void mausb_tcp_device_exit(void) 
+{ 
+ free_mausb_tcp_medium(dev_tcp_medium, MAUSB_TCP_DEV); 
+} 
+module_exit(mausb_tcp_device_exit); 
+ 
+MODULE_LICENSE("Dual BSD/GPL"); 
+MODULE_AUTHOR("Intel"); 
+MODULE_DESCRIPTION("mausb_tcp_device"); 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tcp.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tcp.h
--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tcp.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tcp.h	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,130 @@
+/* Name: mausb_tcp.h 
+ * Description: header file for mausb_tcp.c 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#ifndef __MAUSB_TCP_H 
+#define __MAUSB_TCP_H 
+ 
+#include <linux/net.h> 
+#include <linux/kthread.h> 
+#include <linux/tcp.h> 
+#include <linux/in.h> 
+ 
+#include "mausb_msapi.h" 
+ 
+#define MAUSB_TCP_PORT_HOST 9001 
+ 
+/* used to determine how many times we have to listen */ 
+#define MAUSB_TCP_MAX_NUM_CHANNELS 1 
+ 
+/* how often the device should poll while connecting */ 
+#define MAUSB_TCP_DEV_CONNECT_POLL_MS 100 
+ 
+/* how often to poll the port to check for a new message */ 
+#define MAUSB_TCP_POLL_PORT_MS 5 
+ 
+#define MAUSB_TCP_BUF_SIZE PAGE_SIZE 
+ 
+#define MAUSB_MAX_NAME_LEN 50 
+ 
+#define MAUSB_TCP_RECV_POLL 1 /* in ms */ 
+ 
+#define MAUSB_DWORD_LENGTH 4 /* DWORD = 4 bytes */ 
+ 
+enum mausb_tcp_module_type { 
+ MAUSB_TCP_DEV = 0, 
+ MAUSB_TCP_HOST, 
+ MAUSB_TCP_NUM_MODS 
+}; 
+ 
+struct mausb_tcp_medium { 
+ struct socket *setup_socket; 
+ union { 
+ struct sockaddr_in addr_in; 
+ struct sockaddr addr; 
+ }; 
+ spinlock_t lock; 
+ struct mausb_ma_drv *ma_driver; 
+ 
+ struct socket *socket; 
+ struct task_struct *recv_task; 
+ 
+ /* function call for when a device connect/disconnect is made */ 
+ int (*connect)(int on); 
+}; 
+ 
+/* Used so that host and device side connect functions can run simultaniously. 
+ * See gadget_connection() & gadget_connect_thread() for details. */ 
+struct mausb_connect_data { 
+ struct task_struct *task; 
+ int i; 
+ int on; 
+}; 
+ 
+/* function declarations */ 
+struct mausb_tcp_medium *mausb_tcp_get_medium(void); 
+void *mausb_tcp_to_context(struct mausb_tcp_medium *medium); 
+struct mausb_tcp_medium *mausb_context_to_tcp(void *context); 
+int mausb_tcp_receive_loop(struct mausb_tcp_medium *medium); 
+int mausb_tcp_add_tx_pair(struct mausb_transfer_pair *ma_pair, 
+ struct mausb_tcp_medium *medium); 
+int mausb_tcp_drop_tx_pair(unsigned long handle, void *context); 
+void mausb_free_ms_pkt(struct ms_pkt *pkt); 
+struct mausb_tcp_medium *alloc_init_mausb_tcp_medium( 
+ enum mausb_tcp_module_type type); 
+void free_mausb_tcp_medium(struct mausb_tcp_medium *medium, 
+ enum mausb_tcp_module_type type); 
+ 
+#endif 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tcp-host.c linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tcp-host.c
